proc init_help {} { global help
	set help(about) {
<big>Lavaps 1.9</big>
Copyright (C) 1999 by John Heidemann. All rights reserved. Comments to <computer>johnh@isi.edu</computer>, latest version at <computer>http://www.isi.edu/~johnh/SOFTWARE/LAVAPS/</computer>.


<big>Description</big>
Lavaps is an interactive process-tracking program like ``top'', but with a much different attitude.  Rather than presenting lots of specific info in digital form, it tries to present certain important information in a graphical analog form.  The idea is that you can run it in the background and get a rough idea of what's happening to your system without devoting much concentration to the task.

Lavaps was inspired by Mark Weiser's idea of calm computing in this paper:

Z<>  ``The Coming Age of Calm Technology'' by Mark Weiser and John Seely Brown. A revised version of Weiser & Brown. ``Designing Calm Technology'', PowerGrid Journal, v 1.01, <computer>http://powergrid.electriciti.com/1.01</computer> (July 1996). October, 1996.  <computer>http://www.ubiq.com/hypertext/weiser/acmfuture2endnote.htm</computer>.

(This program dedicated to the memory of M.W.--I hope you would have thought it a good hack.)



}
	set help(basics) {
<big>Controlling Lavaps</big>
Basic lavaps is quite simple. Blobs live and grow corresponding to processes in the system (see "BLOBS"). Clicking the left mouse button on a blob shows information about that process. Clicking the right mouse button pops up menus that let you control lavaps (see "MENUS").


<big>Blobs</big>
Lavaps is all about blobs of virtual, non-toxic lava. Blobs in lavaps correspond to processes in the system. When a process is started, a new blob is created. When a process exits, the corresponding blob disappears. Blob size is proportional to the amount of memory the process uses. Blob movement is proportional to the amount of time the process runs (if the process never runs, the blob will never move).

Blob shows several things. First, the basic color (the hue) corresponds to the name of the program which is running.  Emacs is always one color, Netscape another (on my system, blue and yellow). Second, blobs get darker when the process doesn't run. Over time, the process will become nearly black and only  its border will remain colored. Finally, if both physical and virtual memory are shown, then the part of the process will be a slightly different color showing what percentage of the process is not in physical memory.

Please don't ask me about the chemical composition of the virtual lava.



}
	set help(menus) {
<big>Menus</big>
The right mouse button pops up menus which control lavaps, including:

<italic>Who</italic>: track processes by <italic>me</italic> or by <italic>everyone</italic> (including root, httpd, etc.).

<italic>What</italic>: track process physical or virtual memory or both. Most modern operating systems can keep all of a process in RAM (physical memory), or can let pages that aren't currently used float out to disk (virtual memory). Virtual memory is always a superset of physical memory. You can track either one, or both. When tracking both, virtual memory appears as a different colored strip down the middle of the process blob.

<italic>How</italic>: controls blob sizing. Putting too little or too much lava in your lava lamp would make it boring or overflow. Lavaps therefore usually runs with patent-pending lava <italic>autosizing</italic> where blobs fill about a quarter of the lamp. This feature can be turned off (at your peril) with the How menu. You can also control the desired size of the blobs (when autosizing is enabled) or the absolute size of the blobs (when it's not) with the <italic>Grow</italic> and <italic>Shrink</italic> options.

<italic>Help</italic>: you'll have to figure this one out on your own.

<italic>Quit</italic>: this one's even harder than Help.



}
	set help(resources) {
<big>Resources</big>
Lavaps can configured from X resources (only if they're loaded with xrdb) or with the file <computer>$HOME/.lavapsrc</computer>. In both cases, the format is like:

	lavaps.autosize: false

setting whatever resource you want (in this case autosize) to some value (false). In the <computer>.lavapsrc</computer> file, the ``lavaps'' before the period can be omitted.

The following resources are supported:

geometry  (default none). Specifies the initial window location and size in X-style (see X(1)).

who  (default me). Whose processes should we be watching, anyway? My processes (set to ``me'') or everyones (set to... ``everyone''). Can also be the process id of a single process if you're very single-minded.

what  (default both). What kind of memory should blob size correspond to, either both, physical, or virtual.

autosize  (default true). Keep the blobs at a reasonable size?

debug  (default false).  Enable debugging messages.

checkInterval  (default 2000).  How frequently (in milliseconds) should we check to see who's run?  Defaults to 2 seconds which seems ``reasonable'' on my computer; shorten the interval if you want more frequent updates and have a faster computer (or are more tolerant than I am :-).

clicklessInfo  (default false). If set, process information pops up without clicking. (Not yet fully working.)



}
	set help(copyright) {
<big>Copyright</big>
Lavaps is Copyright (C) 1998-1999 by John Heidemann.

This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License, version 2, as published by the Free Software Foundation.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA.



}
}
